//Filename: filesystem_info.h
/*
 * Sysinfo
 * Copyright (C) Nil Gradisnik 2005 <ghaefb@gmail.com>
 * 
 * Sysinfo is free software.
 * 
 * You may redistribute it and/or modify it under the terms of the
 * GNU General Public License, as published by the Free Software
 * Foundation; either version 2, or (at your option) any later version.
 * 
 * sysinfo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with main.cc.  See the file "COPYING".  If not,
 * write to:  The Free Software Foundation, Inc.,
 *            59 Temple Place - Suite 330,
 *            Boston,  MA  02111-1307, USA.
 */

#ifndef FILESYSTEM_INFO_H
#define FILESYSTEM_INFO_H

#include <iostream>
#include <fstream>

//global variables
Glib::ustring filesys1 = "", filesys2 = "", filesys3 = "", filesys4 = "", filesys5 = "", filesys6 = "", filesys7 = "", filesys8 = "";
Glib::ustring type1 = "", type2 = "", type3 = "",  type4 = "", type5 = "", type6 = "", type7 = "", type8 = "";
Glib::ustring size1 = "", size2 = "", size3 = "", size4 = "", size5 = "", size6 = "", size7 = "", size8 = "";
Glib::ustring used1 = "", used2 = "", used3 = "", used4 = "", used5 = "", used6 = "", used7 = "", used8 = "";
Glib::ustring avail1 = "", avail2 = "", avail3 = "", avail4 = "", avail5 = "", avail6 = "", avail7 = "", avail8 = "";
Glib::ustring use1 = "", use2 = "", use3 = "", use4 = "", use5 = "", use6 = "", use7 = "", use8 = "";
Glib::ustring mount1 = "", mount2 = "", mount3 = "", mount4 = "", mount5 = "", mount6 = "", mount7 = "", mount8 = "";
int line2 = 0, line3 = 0, line4 = 0, line5, line6 = 0, line7 = 0, line8 = 0;

//filesystem df
void Df()
{
	FILE *file;
	
	//first line of df
	char filesys11[50], type11[50], size11[50], used11[50], avail11[50], use11[50], mount11[50];
	
	file = popen("df -hlT | sed -e '2!d' | cut -c 0-9", "r");
	fgets(filesys11, 100, file);
	filesys11[strlen(filesys11)-1] = ' ';
	filesys1 = filesys11;
	pclose(file);
	
	file = popen("df -hlT | sed -e '2!d' | cut -c 11-18", "r");
	fgets(type11, 100, file);
	type11[strlen(type11)-1] = ' ';
	type1 = type11;
	pclose(file);
	
	file = popen("df -hlT | sed -e '2!d' | cut -c 23-26", "r");
	fgets(size11, 100, file);
	size11[strlen(size11)-1] = ' ';
	size1 = size11;
	pclose(file);
	
	file = popen("df -hlT | sed -e '2!d' | cut -c 29-32", "r");
	fgets(used11, 100, file);
	used11[strlen(used11)-1] = ' ';
	used1 = used11;
	pclose(file);
	
	file = popen("df -hlT | sed -e '2!d' | cut -c 35-38", "r");
	fgets(avail11, 100, file);
	avail11[strlen(avail11)-1] = ' ';
	avail1 = avail11;
	pclose(file);
	
	file = popen("df -hlT | sed -e '2!d' | cut -c 40-43", "r");
	fgets(use11, 100, file);
	use11[strlen(use11)-1] = ' ';
	use1 = use11;
	pclose(file);
	
	file = popen("df -hlT | sed -e '2!d' | cut -c 44-70", "r");
	fgets(mount11, 100, file);
	mount11[strlen(mount11)-1] = ' ';
	mount1 = mount11;
	pclose(file);
	
	//second line of df
	char filesys21[50], type21[50], size21[50], used21[50], avail21[50], use21[50], mount21[50];
	
	file = popen("df -hlT | sed -e '3!d' | cut -c 0-9", "r");
	fgets(filesys21, 100, file);
	filesys21[strlen(filesys21)-1] = ' ';
	filesys2 = filesys21;
	if (strstr(filesys21, "/dev/"))
		line2 = 1;
	else
		line2 = 0;
	pclose(file);

	
	file = popen("df -hlT | sed -e '3!d' | cut -c 11-18", "r");
	fgets(type21, 100, file);
	type21[strlen(type21)-1] = ' ';
	type2 = type21;
	pclose(file);
	
	file = popen("df -hlT | sed -e '3!d' | cut -c 23-26", "r");
	fgets(size21, 100, file);
	size21[strlen(size21)-1] = ' ';
	size2 = size21;
	pclose(file);
	
	file = popen("df -hlT | sed -e '3!d' | cut -c 29-32", "r");
	fgets(used21, 100, file);
	used21[strlen(used21)-1] = ' ';
	used2 = used21;
	pclose(file);
	
	file = popen("df -hlT | sed -e '3!d' | cut -c 35-38", "r");
	fgets(avail21, 100, file);
	avail21[strlen(avail21)-1] = ' ';
	avail2 = avail21;
	pclose(file);
	
	file = popen("df -hlT | sed -e '3!d' | cut -c 40-43", "r");
	fgets(use21, 100, file);
	use21[strlen(use21)-1] = ' ';
	use2 = use21;
	pclose(file);
	
	file = popen("df -hlT | sed -e '3!d' | cut -c 44-70", "r");
	fgets(mount21, 100, file);
	mount21[strlen(mount21)-1] = ' ';
	mount2 = mount21;
	pclose(file);
	
	//third line of df
	char filesys31[50], type31[50], size31[50], used31[50], avail31[50], use31[50], mount31[50];
	
	file = popen("df -hlT | sed -e '4!d' | cut -c 0-9", "r");
	fgets(filesys31, 100, file);
	filesys31[strlen(filesys31)-1] = ' ';
	filesys3 = filesys31;
	if (strstr(filesys31, "/dev/"))
		line3 = 1;
	else
		line3 = 0;
	pclose(file);

	file = popen("df -hlT | sed -e '4!d' | cut -c 11-18", "r");
	fgets(type31, 100, file);
	type31[strlen(type31)-1] = ' ';
	type3 = type31;
	pclose(file);	
	
	file = popen("df -hlT | sed -e '4!d' | cut -c 23-26", "r");
	fgets(size31, 100, file);
	size31[strlen(size31)-1] = ' ';
	size3 = size31;
	pclose(file);
	
	file = popen("df -hlT | sed -e '4!d' | cut -c 29-32", "r");
	fgets(used31, 100, file);
	used31[strlen(used31)-1] = ' ';
	used3 = used31;
	pclose(file);
	
	file = popen("df -hlT | sed -e '4!d' | cut -c 35-38", "r");
	fgets(avail31, 100, file);
	avail31[strlen(avail31)-1] = ' ';
	avail3 = avail31;
	pclose(file);
	
	file = popen("df -hlT | sed -e '4!d' | cut -c 40-43", "r");
	fgets(use31, 100, file);
	use31[strlen(use31)-1] = ' ';
	use3 = use31;
	pclose(file);
	
	file = popen("df -hlT | sed -e '4!d' | cut -c 44-70", "r");
	fgets(mount31, 100, file);
	mount31[strlen(mount31)-1] = ' ';
	mount3 = mount31;
	pclose(file);
	
	//forth line of df
	char filesys41[50], type41[50], size41[50], used41[50], avail41[50], use41[50], mount41[50];
	
	file = popen("df -hlT | sed -e '5!d' | cut -c 0-9", "r");
	fgets(filesys41, 100, file);
	filesys41[strlen(filesys41)-1] = ' ';
	filesys4 = filesys41;
	if (strstr(filesys41, "/dev/"))
		line4 = 1;
	else
		line4 = 0;
	pclose(file);
	
	file = popen("df -hlT | sed -e '5!d' | cut -c 11-18", "r");
	fgets(type41, 100, file);
	type41[strlen(type41)-1] = ' ';
	type4 = type41;
	pclose(file);
	
	file = popen("df -hlT | sed -e '5!d' | cut -c 23-26", "r");
	fgets(size41, 100, file);
	size41[strlen(size41)-1] = ' ';
	size4 = size41;
	pclose(file);
	
	file = popen("df -hlT | sed -e '5!d' | cut -c 29-32", "r");
	fgets(used41, 100, file);
	used41[strlen(used41)-1] = ' ';
	used4 = used41;
	pclose(file);
	
	file = popen("df -hlT | sed -e '5!d' | cut -c 35-38", "r");
	fgets(avail41, 100, file);
	avail41[strlen(avail41)-1] = ' ';
	avail4 = avail41;
	pclose(file);
	
	file = popen("df -hlT | sed -e '5!d' | cut -c 40-43", "r");
	fgets(use41, 100, file);
	use41[strlen(use41)-1] = ' ';
	use4 = use41;
	pclose(file);
	
	file = popen("df -hlT | sed -e '5!d' | cut -c 44-70", "r");
	fgets(mount41, 100, file);
	mount41[strlen(mount41)-1] = ' ';
	mount4 = mount41;
	pclose(file);
	
	//fifth line of df
	char filesys51[50], type51[50], size51[50], used51[50], avail51[50], use51[50], mount51[50];
	
	file = popen("df -hlT | sed -e '6!d' | cut -c 0-9", "r");
	fgets(filesys51, 100, file);
	filesys51[strlen(filesys51)-1] = ' ';
	filesys5 = filesys51;
	if (strstr(filesys51, "/dev/"))
		line5 = 1;
	else
		line5 = 0;
	pclose(file);
	
	file = popen("df -hlT | sed -e '6!d' | cut -c 11-18", "r");
	fgets(type51, 100, file);
	type51[strlen(type51)-1] = ' ';
	type5 = type51;
	pclose(file);
	
	file = popen("df -hlT | sed -e '6!d' | cut -c 23-26", "r");
	fgets(size51, 100, file);
	size51[strlen(size51)-1] = ' ';
	size5 = size51;
	pclose(file);
	
	file = popen("df -hlT | sed -e '6!d' | cut -c 29-32", "r");
	fgets(used51, 100, file);
	used51[strlen(used51)-1] = ' ';
	used5 = used51;
	pclose(file);
	
	file = popen("df -hlT | sed -e '6!d' | cut -c 35-38", "r");
	fgets(avail51, 100, file);
	avail51[strlen(avail51)-1] = ' ';
	avail5 = avail51;
	pclose(file);
	
	file = popen("df -hlT | sed -e '6!d' | cut -c 40-43", "r");
	fgets(use51, 100, file);
	use51[strlen(use51)-1] = ' ';
	use5 = use51;
	pclose(file);
	
	file = popen("df -hlT | sed -e '6!d' | cut -c 44-70", "r");
	fgets(mount51, 100, file);
	mount51[strlen(mount51)-1] = ' ';
	mount5 = mount51;
	pclose(file);
	
	//sixth line of df
	char filesys61[50], type61[50], size61[50], used61[50], avail61[50], use61[50], mount61[50];
	
	file = popen("df -hlT | sed -e '7!d' | cut -c 0-9", "r");
	fgets(filesys61, 100, file);
	filesys61[strlen(filesys61)-1] = ' ';
	filesys6 = filesys61;
	if (strstr(filesys61, "/dev/"))
		line6 = 1;
	else
		line6 = 0;
	pclose(file);
	
	file = popen("df -hlT | sed -e '7!d' | cut -c 11-18", "r");
	fgets(type61, 100, file);
	type61[strlen(type61)-1] = ' ';
	type6 = type61;
	pclose(file);
	
	file = popen("df -hlT | sed -e '7!d' | cut -c 23-26", "r");
	fgets(size61, 100, file);
	size61[strlen(size61)-1] = ' ';
	size6 = size61;
	pclose(file);
	
	file = popen("df -hlT | sed -e '7!d' | cut -c 29-32", "r");
	fgets(used61, 100, file);
	used61[strlen(used61)-1] = ' ';
	used6 = used61;
	pclose(file);
	
	file = popen("df -hlT | sed -e '7!d' | cut -c 35-38", "r");
	fgets(avail61, 100, file);
	avail61[strlen(avail61)-1] = ' ';
	avail6 = avail61;
	pclose(file);
	
	file = popen("df -hlT | sed -e '7!d' | cut -c 40-43", "r");
	fgets(use61, 100, file);
	use61[strlen(use61)-1] = ' ';
	use6 = use61;
	pclose(file);
	
	file = popen("df -hlT | sed -e '7!d' | cut -c 44-70", "r");
	fgets(mount61, 100, file);
	mount61[strlen(mount61)-1] = ' ';
	mount6 = mount61;
	pclose(file);
	
	//seventh line of df
	char filesys71[50], type71[50], size71[50], used71[50], avail71[50], use71[50], mount71[50];
	
	file = popen("df -hlT | sed -e '8!d' | cut -c 0-9", "r");
	fgets(filesys71, 100, file);
	filesys71[strlen(filesys71)-1] = ' ';
	filesys7 = filesys71;
	if (strstr(filesys71, "/dev/"))
		line7 = 1;
	else
		line7 = 0;
	pclose(file);
	
	file = popen("df -hlT | sed -e '8!d' | cut -c 11-18", "r");
	fgets(type71, 100, file);
	type71[strlen(type71)-1] = ' ';
	type7 = type71;
	pclose(file);
	
	file = popen("df -hlT | sed -e '8!d' | cut -c 23-26", "r");
	fgets(size71, 100, file);
	size71[strlen(size71)-1] = ' ';
	size7 = size71;
	pclose(file);
	
	file = popen("df -hlT | sed -e '8!d' | cut -c 29-32", "r");
	fgets(used71, 100, file);
	used71[strlen(used71)-1] = ' ';
	used7 = used71;
	pclose(file);
	
	file = popen("df -hlT | sed -e '8!d' | cut -c 35-38", "r");
	fgets(avail71, 100, file);
	avail71[strlen(avail71)-1] = ' ';
	avail7 = avail71;
	pclose(file);
	
	file = popen("df -hlT | sed -e '8!d' | cut -c 40-43", "r");
	fgets(use71, 100, file);
	use71[strlen(use71)-1] = ' ';
	use7 = use71;
	pclose(file);
	
	file = popen("df -hlT | sed -e '8!d' | cut -c 44-70", "r");
	fgets(mount71, 100, file);
	mount71[strlen(mount71)-1] = ' ';
	mount7 = mount71;
	pclose(file);
	
	//eigth line of df
	char filesys81[50], type81[50], size81[50], used81[50], avail81[50], use81[50], mount81[50];
	
	file = popen("df -hlT | sed -e '9!d' | cut -c 0-9", "r");
	fgets(filesys81, 100, file);
	filesys81[strlen(filesys81)-1] = ' ';
	filesys8 = filesys81;
	if (strstr(filesys81, "/dev/"))
		line8 = 1;
	else
		line8 = 0;
	pclose(file);
	
	file = popen("df -hlT | sed -e '9!d' | cut -c 11-18", "r");
	fgets(type81, 100, file);
	type81[strlen(type81)-1] = ' ';
	type8 = type81;
	pclose(file);
	
	file = popen("df -hlT | sed -e '9!d' | cut -c 23-26", "r");
	fgets(size81, 100, file);
	size81[strlen(size81)-1] = ' ';
	size8 = size81;
	pclose(file);
	
	file = popen("df -hlT | sed -e '9!d' | cut -c 29-32", "r");
	fgets(used81, 100, file);
	used81[strlen(used81)-1] = ' ';
	used8 = used81;
	pclose(file);
	
	file = popen("df -hlT | sed -e '9!d' | cut -c 35-38", "r");
	fgets(avail81, 100, file);
	avail81[strlen(avail81)-1] = ' ';
	avail8 = avail81;
	pclose(file);
	
	file = popen("df -hlT | sed -e '9!d' | cut -c 40-43", "r");
	fgets(use81, 100, file);
	use81[strlen(use81)-1] = ' ';
	use8 = use81;
	pclose(file);
	
	file = popen("df -hlT | sed -e '9!d' | cut -c 44-70", "r");
	fgets(mount81, 100, file);
	mount81[strlen(mount81)-1] = ' ';
	mount8 = mount81;
	pclose(file);
		
}


#endif //FILESYSTEM_INFO_H

//ghaefb
